#include "mainwindow.h"
#include "ui_mainwindow.h"

//

void MainWindow::getDatabaseData(){
int list_count;
ui->treeWidget_2->clear();
if (rootItems.isEmpty()) return;



list_count = rootItems.count();

for (int i=0; i < list_count; i++){

    buildTree(rootItems.at(i));

}

}

void MainWindow::buildTree(QTreeWidgetItem * model_item){




QString model_name;
QString rootClassID;
QString rootClassInctance;
QFont font;

QTreeWidgetItem * item;
model_name = model_item->text(0);
if (model_item->checkState(0) == false) return;

//ui->treeWidget_2->clear();
//font.setWeight(20);
font.setItalic(true);
item = new QTreeWidgetItem (ui->treeWidget_2);
item->setFont(0, font);
item->setText(0, model_name);
item->setTextColor(0, Qt::darkGreen);
root_items_list << item; //     

if (!(model_item->childCount() > 0)) return;

rootClassID = model_item->child(0)->text(1);
rootClassInctance = getClassInctance(rootClassID);


if (model_item->child(0)->checkState(0)) //         ( ), 
    {
     /////   QTreeWidgetItem * item_tmp;
   /////     item_tmp = new QTreeWidgetItem(item);                  //  ,   ,   
   /////     item_tmp->setText(0, model_item->child(0)->text(0));    //   

        //showClassObjects(item_tmp, model_item->child(0));  //      

        ///// showObjects(item_tmp, model_item->child(0), tr(""));
    showObjects(item, model_item->child(0), tr(""));
    }


/*****************************************************/


}


//    -   
QString MainWindow::getClassInctance(QString class_id){
    QSqlQuery q;
    QString sql_str;
    QString result;
    QString classInctance;
    int field_inctance;
    bool ok;
    sql_str = tr("select * "
                 " from ListOfClasses where  ListOfClasses.ID = '"       // ,     
                 );
    sql_str.append(class_id);
     sql_str.append(tr("'"));
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return result;
                     }
    field_inctance = q.record().indexOf(tr("TableWhithInstance"));
    while(q.next()){

                  classInctance = q.value(field_inctance).toString();
                  result.append(classInctance);
                  }

  return result;

}

void MainWindow::showClassObjects(QTreeWidgetItem * parent_item, QTreeWidgetItem * model_item){
    QString classID; //  
    QString inctance; //  , 
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    bool ok;
    int field_ID;
    int i;
    QIcon icon;
    classID = model_item->text(1);
    inctance = getClassInctance(classID);
    icon = model_item->icon(0);
    sql_str = tr("select * "
                 " from "       //      -   
                 );
    sql_str.append(inctance);
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return;
                     }

    field_ID = q.record().indexOf(tr("ID"));


    while(q.next()){
                  if (q.record().count() > 1)
                  {
                    QString value_tmp;
                    QString ID_tmp;
                    QTreeWidgetItem * itm;
                    ID_tmp = q.value(field_ID).toString(); //   
                    value_tmp = q.value(1).toString(); //    (    )
                    itm = new QTreeWidgetItem(parent_item); //    ,  
                    itm->setText(0, value_tmp);

                    itm->setIcon(0, icon);

                    for (int i; i < model_item->childCount(); i++) // ,      
                    {
                        QTreeWidgetItem * model_item_tmp;           //  
                        model_item_tmp = model_item->child(i);      //    
                        MainWindow::showObjectChildrens(ID_tmp, itm, model_item_tmp);

                    }
                  }

             }

    
    i++;
}



void MainWindow::showObjectChildrens(QString object_ID, QTreeWidgetItem * object_item, QTreeWidgetItem * model_item){ //   

    QString classID; //  

    QString inctance; //  , 
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    bool ok;
    classID = model_item->text(1);
    inctance = getClassInctance(classID);

    sql_str = tr("select * "
                 " from '"       //      -   
                 );
    sql_str.append(inctance);
    sql_str.append(tr("' where "));


    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return;
                     }
}



//
void MainWindow::showObjects(QTreeWidgetItem * parent_object_item, QTreeWidgetItem * model_item, QString filtr){
    QString classID; //  
    QString parentClassID; //   
    QString pointerField; //  -   
    QString inctance; //  , 
    QString className; //  
    QString modelID; //  
    QString add_filtr; //  
    int field_ID;
    int icon_field_index;
    bool filtr_empty;
    bool ok;
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    QTreeWidgetItem * title_item;
    QFont font;
    QIcon icon;
   // font.setWeight(40);
    font.setBold(true);
    filtr_empty = filtr.isEmpty();

    classID = model_item->text(1);
    modelID = model_item->text(6);
    add_filtr = MainWindow::getFiltrString(modelID, classID);


    icon = model_item->icon(0);

    parentClassID = model_item->parent()->text(1);

    pointerField = getPointerFieldName(parentClassID, classID);

    className = model_item->text(0);
    inctance = getClassInctance(classID);

    if  (!model_item->checkState(0)) return;

    title_item = new  QTreeWidgetItem(parent_object_item);
    title_item->setFont(0, font);
    title_item->setText(0, className);
    title_item->setText(1, tr("class"));
    title_item->setText(2, classID);
    title_item->setText(3, inctance);
    title_item->setText(4, pointerField);
    title_item->setText(5, add_filtr); //        
    title_item->setTextColor(0, Qt::darkBlue);

     title_item->setIcon(0, icon);


    sql_str = tr("select * "
                 " from "       //      -   
                 );
    sql_str.append(inctance);


    if (filtr.isEmpty() && (!add_filtr.isEmpty())) //  ,    
                            {
                                filtr.append(tr ("where "));
                                filtr.append(add_filtr);
                             }


    if (!filtr.isEmpty())   { //    
                                 sql_str.append(tr(" "));
                                 sql_str.append(filtr); //    
                            }

    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QString debug_str;
                            debug_str.append(tr(" showObjects(): Database Error "));
                            debug_str.append(tr(" : "));
                            debug_str.append(inctance);
                            debug_str.append(tr(" : "));
                            debug_str.append(filtr);
                            debug_str.append(q.lastError().text());
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr(" showObjects(): Database Error"),   // .
                                                                            debug_str
                                                                           // q.lastError().text()
                                                                             );          //  .
                                                                            return;
                     }

    field_ID = q.record().indexOf(tr("ID"));

    icon_field_index = q.record().indexOf(tr("Icon"));
    /*
    if (q.size() <= 0) return;
    title_item = new  QTreeWidgetItem(parent_object_item);
    title_item->setFont(0, font);
    title_item->setText(0, className);
    */

    while(q.next()){
                  if (q.record().count() > 1)
                  {
                    QString value_tmp;
                    QString ID_tmp;
                    QTreeWidgetItem * itm;
                    ID_tmp = q.value(field_ID).toString(); //   
                    value_tmp = q.value(1).toString(); //    (    )
               //     itm = new QTreeWidgetItem(parent_object_item); //    ,  
                    itm = new QTreeWidgetItem(title_item); //    ,  
                    itm->setText(0, value_tmp);
                    itm->setText(1, tr("object"));
                    itm->setText(2, ID_tmp);


                    if  (icon_field_index != -1){ //     
                        QVariant data;
                        QByteArray bytes;
                        QPixmap pix;
                        QIcon icn;
                        QMap <QString, QPixmap> pixmap_map;
                        QList <QString> id_list;
                        QList <QPixmap> pixmap_list;
                        pixmap_map = MainWindow::getObjectsIcon(inctance);
                        if (!pixmap_map.isEmpty()) {
                            id_list = pixmap_map.keys();
                            pixmap_list =  pixmap_map.values();
                        }
                        if (id_list.indexOf(ID_tmp) != -1) {
                            pix = pixmap_list.at(id_list.indexOf(ID_tmp));
                        }
                      // data = q.record().value(icon_field_index);
                      //  bytes = q.record().value(icon_field_index).toByteArray();
                        // if (data.isValid() && (!data.isNull())) {
                     //   if (!bytes.isEmpty()){
                        // pix.loadFromData(data.toByteArray());
                        // pix.loadFromData(bytes);
                        if (pix.height() > 128) pix = pix.scaledToHeight(128);
                        icn.addPixmap(pix);
                        itm->setIcon(0, icn);
                     //  }



                    }



//                    itm->setIcon(0, icon);


                    for (int i=0; i < model_item->childCount(); i++) // ,      
                    {
                        QTreeWidgetItem * model_item_tmp;           //  
                        QString pointer_name;
                        QString filtr_tmp;
                        bool pointer_isEmpty;
                        model_item_tmp = model_item->child(i);      //    
                        pointer_name = getPointerFieldName(classID, model_item->child(i)->text(1));
                        itm->setText(4, pointer_name);

                      //  title_item->setText(4, pointer_name);


                        pointer_isEmpty = pointer_name.isEmpty();
                        filtr_tmp = tr("where ");
                        filtr_tmp.append(tr("`"));
                        filtr_tmp.append(pointer_name);
                        filtr_tmp.append(tr("` = '"));
                        filtr_tmp.append(ID_tmp);
                         filtr_tmp.append(tr("'"));
                        showObjects(itm,  model_item_tmp, filtr_tmp);
                        //MainWindow::showObjectChildrens(ID_tmp, itm, model_item_tmp);

                    }


                }

              }




    for (int i; i < model_item->childCount(); i++) // ,      
        {


        }

}


QString MainWindow::getPointerFieldName(QString parent_class_id, QString chield_class_id){

    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    QString field;
    QString result;
    int field_name;
    bool ok;
    sql_str = tr("select * "
                 " from `DescriptionOfClasses` where `DescriptionOfClasses`.`FieldType` = 'pointer' and  `DescriptionOfClasses`.`DefaultValue` = "       //      -   
                 );

    sql_str.append(tr("'"));
    sql_str.append(parent_class_id);
    sql_str.append(tr("' "));
    sql_str.append(tr(" and  `DescriptionOfClasses`.`ClassIdentifer` = '"));
    sql_str.append(chield_class_id);
    sql_str.append(tr("'"));
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return result;
                     }
field_name =  q.record().indexOf(tr("FieldName"));
while(q.next()){
        result = q.value(field_name).toString();
    }
return result;
}



void MainWindow::on_treeWidget_2_itemClicked ( QTreeWidgetItem * item, int column ){
QString item_type; //   (   )
QString parent_object_id;
int i;
QTreeWidgetItem * parent_item;
item_type = item->text(1);
parent_item = item->parent();

QString  class_id; //   
QString inctance;
QString filtr_tmp;
QMap <QString, QString> pointersList;
QStringList dateFieldList; //      "DATE"
QStringList boolFieldList; //      "BOOL"
QStringList fileFieldList; //   ,    
QString pointer_name; //   

if (item_type == tr("object") || item_type == tr("class")){

disconnect(sql_mogel, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_sql_mogel_dataChanged(QModelIndex,QModelIndex)));

static QList<int> colomns_indexes; //       
static QList<int> date_colomns_indexes; //         "DATE"
static QList <int> bool_colomns_indexes; //         "BOOL"
static QList <int> file_colomns_indexes; //    ,    

static QList<SpinBoxDelegate *> spin_delegate_list;//     
static int icon_index = -1; //    


SpinBoxDelegate * spin_delegate_tmp;

//  ""    

if (icon_index != -1) {
                            ui->tableView->setItemDelegateForColumn(icon_index, &standart_delegate); //    
                            icon_index = -1;
                       }

for (i=0; i < colomns_indexes.size(); i++){ //   -:
    ui->tableView->setItemDelegateForColumn(colomns_indexes.at(i), &standart_delegate ); //    
// ui->tableView->setItemDelegateForColumn(colomns_indexes.at(i), &picture_delegate);

}
colomns_indexes.clear(); //      


//  ""      

for (i=0; i < file_colomns_indexes.size(); i++){ //   -:
    ui->tableView->setItemDelegateForColumn(file_colomns_indexes.at(i), &standart_delegate ); //    
}
file_colomns_indexes.clear();


// ""      "DATE"
for (i=0; i < date_colomns_indexes.size(); i++){ //   -:
    ui->tableView->setItemDelegateForColumn(date_colomns_indexes.at(i), &standart_delegate ); //    
// ui->tableView->setItemDelegateForColumn(colomns_indexes.at(i), &picture_delegate);

}

date_colomns_indexes.clear();

// ""      "BOOL"
for (i=0; i < bool_colomns_indexes.size(); i++){ //   -:
    ui->tableView->setItemDelegateForColumn(bool_colomns_indexes.at(i), &standart_delegate ); //    
// ui->tableView->setItemDelegateForColumn(colomns_indexes.at(i), &picture_delegate);

}

bool_colomns_indexes.clear();
boolFieldsIndexes_global.clear();

if (item_type == tr("object"))
    {
          QString ID;
        ui->pushButton->setEnabled(false);
        ui->pushButton_2->setEnabled(false);

        class_id = parent_item->text(2);
        ID = item->text(2);
        inctance = parent_item->text(3);
        delete sql_mogel;

        sql_mogel = new MyModel();

        sql_mogel->setTable(inctance);
        // sql_mogel->setEditStrategy(QSqlTableModel::OnFieldChange);
        sql_mogel->setEditStrategy(QSqlTableModel::OnManualSubmit);

        filtr_tmp.append(tr("`"));
        filtr_tmp.append(tr("ID"));
        filtr_tmp.append(tr("`"));
        filtr_tmp.append(tr(" = '"));
        filtr_tmp.append(ID);
        filtr_tmp.append(tr("'"));

    }
if (item_type == tr("class"))
    {
        QString parent_object_id; //   

        QString parent_class_inctance;
        QString class_filter;


        ui->pushButton->setEnabled(true);
        ui->pushButton_2->setEnabled(true);

        parent_object_id = parent_item->text(2);

        parentObject_id = parent_item->text(2);

        class_id = item->text(2);
        inctance = item->text(3);
        class_filter = item->text(5);

        pointer_name = item->text(4);
        delete sql_mogel;

        sql_mogel = new MyModel();

        //        sql_mogel = new QSqlTableModel(this);
        sql_mogel->setTable(inctance);
        // sql_mogel->setEditStrategy(QSqlTableModel::OnFieldChange);
        sql_mogel->setEditStrategy(QSqlTableModel::OnManualSubmit);

        if (!parent_object_id.isEmpty())
        {
            filtr_tmp.append(tr("`"));
            filtr_tmp.append(pointer_name);
            filtr_tmp.append(tr("`"));
            filtr_tmp.append(tr(" = '"));
            filtr_tmp.append(parent_object_id);
            filtr_tmp.append(tr("'"));


            if (!class_filter.isEmpty()) //      
                {
                    filtr_tmp.append(tr(" and "));
                    filtr_tmp.append(class_filter); //      (    )

                }




        }
        else if(!class_filter.isEmpty()) //      ,   
            {
                 filtr_tmp.append(class_filter); //      (    )
            }

    }



pointersList = getPointersList(class_id); //   -
dateFieldList = getDataFieldList(class_id); //    c  "DATE"
boolFieldList = getBoolFieldList(class_id); //    c  "BOOL"
fileFieldList = getFileFieldList(class_id); //   ,    

icon_index = getIconFieldIndex(inctance); //
if (icon_index != -1) ui->tableView->setItemDelegateForColumn(icon_index, iconDelegate);
sql_mogel->setIconIndex(icon_index);

QMap <int, QString> pointersToModel;




QMap <int, QString> filesFieldsToModel;
for (int i=0; i < fileFieldList.count(); i++){ //   ,  
  //  static FileDelegate flDelegate;
   // static TimeEditDelegate dateDelegate("01.10.2010");
    QString fileFieldName; //  
    int fileFieldIndex; //
    fileFieldName = fileFieldList.at(i); //   ,  
    fileFieldIndex = sql_mogel->record().indexOf(fileFieldName); //     
    filesFieldsToModel.insert(fileFieldIndex, fileFieldName);
    file_colomns_indexes.append(fileFieldIndex);//        "file"
    ui->tableView->setItemDelegateForColumn(fileFieldIndex, fileDelegate);

}
sql_mogel->setFilesFields(filesFieldsToModel);//         ,  




for (int i=0; i < dateFieldList.count(); i++){ //      "DATA"
     static MyDEDelegate dateDelegate;
   // static TimeEditDelegate dateDelegate("01.10.2010");
    QString dateFieldName; //  
    int dataFieldIndex; //
    dateFieldName = dateFieldList.at(i); //      "DATA"
    dataFieldIndex = sql_mogel->record().indexOf(dateFieldName); //     
    date_colomns_indexes.append(dataFieldIndex);//        "DATA"
    ui->tableView->setItemDelegateForColumn(dataFieldIndex, &dateDelegate);

}


for (int i=0; i < boolFieldList.count(); i++){ //      "BOOL"
   // // // //  static MyDEDelegate dateDelegate;
   // static TimeEditDelegate dateDelegate("01.10.2010");
    QString boolFieldName; //  
    int boolFieldIndex; //
    boolFieldName = boolFieldList.at(i); //      "BOOL"
    boolFieldIndex = sql_mogel->record().indexOf(boolFieldName); //     
    bool_colomns_indexes.append(boolFieldIndex);//      "DATA"
        // ui->tableView->setItemDelegateForColumn(dataFieldIndex, &dateDelegate);

}

sql_mogel->setBooleansList(bool_colomns_indexes);
boolFieldsIndexes_global = bool_colomns_indexes;

for (int i=0; i < spin_delegate_list.count(); i++){ //   
delete spin_delegate_list.at(i);
 }

spin_delegate_list.clear(); //      

QStringList pointersNames;
pointersNames = pointersList.keys(); //   -   





//   ui->tableView->setItemDelegateForColumn(2, picture_delegate);

// ui->tableView->setRowHeight(1, 100);





QStringList parentInctancesList = pointersList.values(); //    

for (i=0; i < pointersNames.size(); i++){ //   -:
    QString pointerName;

    int pointerIndex;
    pointerName = pointersNames.at(i);  //   -
    pointerIndex = sql_mogel->record().indexOf(pointerName); //     
    colomns_indexes.append(pointerIndex); //      
    spin_delegate_tmp = new SpinBoxDelegate();

    // // spinDelegate.setInctance(parentInctancesList.at(i)); //       
    // // spinDelegate.getItems();                             //       

    spin_delegate_tmp->setInctance(parentInctancesList.at(i));
    spin_delegate_tmp->getItems();

    spin_delegate_list.append(spin_delegate_tmp);

  // // ui->tableView->setItemDelegateForColumn(pointerIndex, &spinDelegate); //       

    ui->tableView->setItemDelegateForColumn(pointerIndex, spin_delegate_tmp);

    pointersToModel.insert(pointerIndex, parentInctancesList.at(i)); //     
}

sql_mogel->setPointers(pointersToModel); //    

pointer_index = sql_mogel->record().indexOf(pointer_name); //   ,  , ! :-)




sql_mogel->setFilter(filtr_tmp);
sql_mogel->setSort(1, Qt::AscendingOrder);
sql_mogel->select();



connect(sql_mogel, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_sql_mogel_dataChanged(QModelIndex,QModelIndex)));

ui->tableView->setModel(sql_mogel);
ui->tableView->hideColumn(0);
ui->tableView->resizeColumnsToContents();
ui->tableView->resizeRowsToContents();





    }

}


void MainWindow::on_pushButton_clicked(){ //   " "
     int row = sql_mogel->rowCount();
      sql_mogel->insertRows(row, 1);
      sql_mogel->setData(sql_mogel->index(row, 1), QVariant(tr(" ")), Qt::EditRole); //     " "
      if (pointer_index > 0) {
                                    sql_mogel->setData(sql_mogel->index(row, pointer_index), QVariant(parentObject_id), Qt::EditRole); //     " "
                                }
    //  sql_mogel->submitAll();

}

void MainWindow::on_pushButton_2_clicked(){ //   "  "
int i;
i++;
QModelIndex model_index;
QItemSelectionModel *selectionModel = ui->tableView->selectionModel();
QModelIndexList indexes = selectionModel->selectedIndexes();
QList<int> selectedRows;
selectedRows.clear();
foreach (model_index, indexes){ //    
    if (!selectedRows.contains(model_index.row()) && (model_index.column()==1))  selectedRows.append(model_index.row()); //        

}
qSort(selectedRows.begin(),selectedRows.end(), qGreater<int>()); //    


for (int m =0; m < selectedRows.size(); ++m){

// ClassEditor::removeClass(selectedRows.at(m));

sql_mogel->removeRow(selectedRows.at(m));

}
sql_mogel->submitAll();
getDatabaseData();

}


void MainWindow::on_pushButton_3_clicked(){ //   ""
    int i;
    i++;
    sql_mogel->submitAll();
    getDatabaseData();
    ui->pushButton_3->setEnabled(false);
    ui->pushButton_4->setEnabled(false);
    sql_mogel->select();

}


void MainWindow::on_pushButton_4_clicked(){ //   " "
    int i;
    i++;
    sql_mogel->select();
    ui->pushButton_3->setEnabled(false);
    ui->pushButton_4->setEnabled(false);
    ui->tableView_2->resizeRowsToContents();
    ui->tableView_2->resizeColumnsToContents();
}


void MainWindow::on_pushButton_5_clicked(){//   "  "

    int i;
    i++;
    int row = model_for_ListModelsTable->rowCount();
    model_for_ListModelsTable->insertRows(row, 1);
    model_for_ListModelsTable->setData(model_for_ListModelsTable->index(row, 1), QVariant(tr(" ")), Qt::EditRole); //     " "
    // model_for_ListModelsTable->setData(sql_mogel->index(row, pointer_index), QVariant(parentObject_id), Qt::EditRole); //     " "

   //  sql_mogel->submitAll();


}

void MainWindow::on_pushButton_6_clicked(){//   "  "

    QModelIndex model_index;
    QItemSelectionModel *selectionModel = ui->tableView_2->selectionModel();
    QModelIndexList indexes = selectionModel->selectedIndexes();
    QList<int> selectedRows;
    selectedRows.clear();
    foreach (model_index, indexes){ //    
        if (!selectedRows.contains(model_index.row()) && (model_index.column()==1))  selectedRows.append(model_index.row()); //        

    }
    qSort(selectedRows.begin(),selectedRows.end(), qGreater<int>()); //    


    for (int m =0; m < selectedRows.size(); ++m){

    // ClassEditor::removeClass(selectedRows.at(m));

    model_for_ListModelsTable->removeRow(selectedRows.at(m));

    }
    model_for_ListModelsTable->submitAll();
    ui->pushButton_7->setEnabled(true);
   // getDatabaseData();

}


void MainWindow::on_pushButton_7_clicked(){//   ""
model_for_ListModelsTable->submitAll();
ui->pushButton_7->setEnabled(false);
ui->pushButton_8->setEnabled(false);
model_is_build = false;
MainWindow::readModels();
model_is_build = true;
MainWindow::getDatabaseData();
}

void MainWindow::on_pushButton_8_clicked(){//   "" (  )
model_for_ListModelsTable->select();
ui->pushButton_7->setEnabled(false);
ui->pushButton_8->setEnabled(false);

}


 void MainWindow::on_pushButton_9_clicked()//   " " (  )
 {
    QString class_id;
    QString model_id;


    class_id = ui->treeWidget->currentItem()->text(1);
    model_id = ui->treeWidget->currentItem()->text(6);
     int row = filter_model->rowCount();
     filter_model->insertRows(row, 1);
    filter_model->setData(filter_model->index(row, 1), QVariant(model_id), Qt::EditRole); //     "Model ID"
    filter_model->setData(filter_model->index(row, 2), QVariant(class_id), Qt::EditRole); //     "Class ID"
    ui->pushButton_11->setEnabled(true);
    ui->pushButton_12->setEnabled(true);


 }

  void MainWindow::on_pushButton_10_clicked()//   " " (  )
  {
      QModelIndex model_index;
      QItemSelectionModel *selectionModel = ui->tableView_3->selectionModel();
      QModelIndexList indexes = selectionModel->selectedIndexes();
      QList<int> selectedRows;
      selectedRows.clear();
      foreach (model_index, indexes){ //    
          if (!selectedRows.contains(model_index.row()) /*&& (model_index.column()==1)*/)  selectedRows.append(model_index.row()); //        

      }
      qSort(selectedRows.begin(),selectedRows.end(), qGreater<int>()); //    


      for (int m =0; m < selectedRows.size(); ++m){

      // ClassEditor::removeClass(selectedRows.at(m));

      filter_model->removeRow(selectedRows.at(m));

      }
      filter_model->submitAll();

      filter_model->sort(0,Qt::AscendingOrder);
     // getDatabaseData();
      model_is_build = false;
      MainWindow::readModels();
      model_is_build = true;
      MainWindow::getDatabaseData();

      disconnect(filter_model, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_filter_model_dataChanged(QModelIndex,QModelIndex)));
    delete filter_model;

    filter_model = new QSqlTableModel();
     filter_model->setEditStrategy(QSqlTableModel::OnManualSubmit);
   /// filter_model = new MyModel();

    connect(filter_model, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_filter_model_dataChanged(QModelIndex,QModelIndex)));




  }

  void MainWindow::on_pushButton_11_clicked()//   "" (  )
  {
      filter_model->submitAll();
      filter_model->sort(0,Qt::AscendingOrder);
      ui->pushButton_11->setEnabled(false);
      ui->pushButton_12->setEnabled(false);

      model_is_build = false;
      MainWindow::readModels();
      model_is_build = true;
      MainWindow::getDatabaseData();
      disconnect(filter_model, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_filter_model_dataChanged(QModelIndex,QModelIndex)));
    delete filter_model;

    filter_model = new QSqlTableModel();
    filter_model->setEditStrategy(QSqlTableModel::OnManualSubmit);
   /// filter_model = new MyModel();

    connect(filter_model, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_filter_model_dataChanged(QModelIndex,QModelIndex)));



  }

  void MainWindow::on_pushButton_12_clicked()//   " " (  )
  {
    ui->tableView_3->setModel(filter_model);
    filter_model->select();

    ui->pushButton_11->setEnabled(false);
    ui->pushButton_12->setEnabled(false);
  }

  void MainWindow::on_pushButton_13_clicked()//   "  " (  )
  {
        buildReport(false);

  }

  void MainWindow::on_pushButton_14_clicked()//   "  " (  )
  {
        buildReport(true);

  }

  void MainWindow::on_pushButton_15_clicked()//    "" (  )
  {
        QPrinter printer;
        QPrintDialog *dlg = new QPrintDialog(&printer, this);
        if (dlg->exec() !=QDialog::Accepted) return;
        doc->print(&printer);

  }


  void MainWindow::on_pushButton_16_clicked()//   "  PDF" (  )
  {
      QString fileName = QFileDialog::getSaveFileName(this, "Export PDF", "", "PDF Files (*.pdf)");
      if(!fileName.isEmpty()){
          if (QFileInfo(fileName).suffix().isEmpty())
              fileName.append(".pdf");
          QPrinter printer(QPrinter::HighResolution);
          printer.setOutputFormat(QPrinter::PdfFormat);
          printer.setOutputFileName(fileName);
          doc->print(&printer);
      }

  }

 void MainWindow::on_pushButton_17_clicked()//   "  OpenOffice" (  )

 {
        QString fileName = QFileDialog::getSaveFileName(this, "Export ODT", "", "OpenOffice document (*.odt)");

      if(!fileName.isEmpty()){
        if (QFileInfo(fileName).suffix().isEmpty())
            fileName.append(".odt");
      (bool)QTextDocumentWriter(fileName).write(doc);

    }


 }


 void MainWindow::on_pushButton_18_clicked()//  wmi 

 {
     /*

     //	QString program = tr(" wmic -U %Patr10t //192.168.0.135 \"select * from Win32_ComputerSystem\"");
             QString program = tr("wmic");
             QStringList arguments;

     //	arguments << tr(" -U %Patr10t //192.168.0.135 \"select * from Win32_ComputerSystem\"");
          //   program.append(tr(" -U %Patr10t //192.168.0.135 \"select * from Win32_ComputerSystem\""));
             program.append(tr(" -U admin --password=samba //192.168.0.101 \"select * from "));    //Win32_Product\""));
             program.append(ui->comboBox_2->currentText());
             program.append(tr("\""));

             int i;
             i++;
             wmiProcess.start(program);
    */

     TWmiVideoCard vCard;



     vCard = MainWindow::getWmiVideoGard("192.168.0.11", tr(""), "!s-Leg01@Z");
    int i;
    i++;



 }


void MainWindow::on_sql_mogel_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ){ //       
int i;
i++;

if (sql_mogel->iconIndex() !=-1) {
                                    ui->tableView->resizeColumnsToContents();
                                    ui->tableView->resizeRowsToContents();
                                    }

if ((topLeft == bottomRight) && (boolFieldsIndexes_global.indexOf(topLeft.column()) != -1))
{
    ui->pushButton_3->setEnabled(false);
    ui->pushButton_4->setEnabled(false);
return;
}


ui->pushButton_3->setEnabled(true);
ui->pushButton_4->setEnabled(true);

}

void MainWindow::on_model_for_ListModelsTable_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ){ //       

ui->pushButton_7->setEnabled(true);
ui->pushButton_8->setEnabled(true);
}




void MainWindow::on_filter_model_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight ) //       

{
    ui->pushButton_11->setEnabled(true);
    ui->pushButton_12->setEnabled(true);
}





//    -,      -
//      -   

QMap <QString, QString>  MainWindow::getPointersList(QString class_id){
    QMap <QString, QString>  result_map;
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    QString field;
    QString result;
    int field_name, field_default_value;
    bool ok;
    sql_str = tr("select * "
                 " from `DescriptionOfClasses` where `DescriptionOfClasses`.`FieldType` = 'pointer' and  `DescriptionOfClasses`.`ClassIdentifer` = "       //      -   
                 );

    sql_str.append(tr("'"));
    sql_str.append(class_id);
    sql_str.append(tr("' "));
    // sql_str.append(tr(" and  `DescriptionOfClasses`.`ClassIdentifer` = '"));
    // sql_str.append(chield_class_id);
    // sql_str.append(tr("'"));
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return result_map;
                     }
field_name =  q.record().indexOf(tr("FieldName"));
field_default_value = q.record().indexOf(tr("DefaultValue"));
while(q.next()){
        QString pointerFieldName;
        QString parentClassID;
        QString parentClassInctance;

         pointerFieldName = q.value(field_name).toString();
         parentClassID = q.value(field_default_value).toString();
         parentClassInctance =  getClassInctance(parentClassID);
         result_map.insert(pointerFieldName, parentClassInctance);


    }

return result_map;
}





QStringList MainWindow::getDataFieldList(QString class_id){ //     c  "",      
                                                            //      -   

    QStringList  result_str;
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    QString field;
    QString result;
    int field_name, field_default_value;
    bool ok;
    sql_str = tr("select * "
                 " from `DescriptionOfClasses` where `DescriptionOfClasses`.`FieldType` = 'DATE' and  `DescriptionOfClasses`.`ClassIdentifer` = "       //      -   
                 );

    sql_str.append(tr("'"));
    sql_str.append(class_id);
    sql_str.append(tr("' "));
    // sql_str.append(tr(" and  `DescriptionOfClasses`.`ClassIdentifer` = '"));
    // sql_str.append(chield_class_id);
    // sql_str.append(tr("'"));
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return result_str;
                     }
field_name =  q.record().indexOf(tr("FieldName"));
// field_default_value = q.record().indexOf(tr("DefaultValue"));
while(q.next()){
        QString DataFieldName;

         DataFieldName = q.value(field_name).toString();
         result_str.append(DataFieldName);


    }

return result_str;
}



int MainWindow::getIconFieldIndex(QString inctance){ //     

    QSqlQuery q;
    bool ok;
    int icon_field;
    QString sql_str;
    sql_str = tr("select * from `"); //      -   
    sql_str.append(inctance);
    sql_str.append(tr("`"));
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .

                                return -1;
                     }

    icon_field =  q.record().indexOf(tr("Icon"));
    return icon_field;


}


QStringList MainWindow::getFileFieldList(QString class_id){ //    ,    
QStringList  result_str;
QSqlQuery q;
QString sql_str;
bool ok;
 int field_name, field_default_value;
 sql_str = tr("select * "
              " from `DescriptionOfClasses` where `DescriptionOfClasses`.`Comment` = 'file' and  `DescriptionOfClasses`.`ClassIdentifer` = "       //      -   
              );
 sql_str.append(tr("'"));
 sql_str.append(class_id);
 sql_str.append(tr("' "));
 q.prepare(sql_str);

 ok = q.exec();
 if (!ok) {
                         QMessageBox::critical( //     .
                                                                         this,                      //  .
                                                                         QObject::tr("Database Error"),   // .
                                                                         q.lastError().text());          //  .
                                                                         return result_str;
                  }

 field_name =  q.record().indexOf(tr("FieldName"));
 // field_default_value = q.record().indexOf(tr("DefaultValue"));
 while(q.next()){
         QString FileFieldName;

          FileFieldName = q.value(field_name).toString();
          result_str.append(FileFieldName);


     }

 return result_str;

}



QStringList MainWindow::getBoolFieldList(QString class_id){ //     c  "bool"

    QStringList  result_str;
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    QString field;
    QString result;
    int field_name, field_default_value;
    bool ok;
    sql_str = tr("select * "
                 " from `DescriptionOfClasses` where `DescriptionOfClasses`.`FieldType` = 'BOOL' and  `DescriptionOfClasses`.`ClassIdentifer` = "       //      -   
                 );

    sql_str.append(tr("'"));
    sql_str.append(class_id);
    sql_str.append(tr("' "));
    // sql_str.append(tr(" and  `DescriptionOfClasses`.`ClassIdentifer` = '"));
    // sql_str.append(chield_class_id);
    // sql_str.append(tr("'"));
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return result_str;
                     }
field_name =  q.record().indexOf(tr("FieldName"));
// field_default_value = q.record().indexOf(tr("DefaultValue"));
while(q.next()){
        QString DataFieldName;

         DataFieldName = q.value(field_name).toString();
         result_str.append(DataFieldName);


    }

return result_str;
}





//  

void MainWindow::readSettings()
{
        QSettings settings("Trolltech", "Application Example");
        baseName = settings.value("baseName", "an_db").toString();
        userName = settings.value("userName", "an").toString();
        password = settings.value("password", "393939").toString();
        tableName = settings.value("tableName", "inventar").toString();
        hostName = settings.value("hostName", "server").toString();
//     resize(size);
//     move(pos);tableName
}


void MainWindow::writeSettings()
{
        QSettings settings("Trolltech", "Application Example");
        settings.setValue("baseName", baseName);
        settings.setValue("userName", userName);
        settings.setValue("password", password);
        settings.setValue("tableName", tableName);
        settings.setValue("hostName", hostName);
}



void MainWindow::applySetting()
{
        bool ok;
        baseName = setFrm.lineEdit->text();
        userName = setFrm.lineEdit_2->text();
        password = setFrm.lineEdit_3->text();
        // tableName = setFrm->lineEdit_4->text();
        hostName = setFrm.lineEdit_5->text();
        writeSettings();


        ok=openDataBase();
        if (!ok) return;
   // // //     ui->treeWidget->clear(); //    

   // // //      buildPreviewModel(tr(" "), tr("1"));

        model_is_build = false;

        class_list_map.clear(); //   
        rootItems.clear();
        models_items.clear();

        disconnect(model_for_ListModelsTable, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_model_for_ListModelsTable_dataChanged(QModelIndex,QModelIndex)));
        delete model_for_ListModelsTable;

        initListModelsTablle();

        connect(model_for_ListModelsTable, SIGNAL(dataChanged(QModelIndex,QModelIndex)), this, SLOT(on_model_for_ListModelsTable_dataChanged(QModelIndex,QModelIndex)));

        ui->treeWidget->clear();
        initComboBox();
 //       model_for_ListModelsTable->select();
        MainWindow::readModels();



  // // //      getDatabaseData();
        // delete setFrm;


        model_is_build = true;
        getDatabaseData();
        setFrm.close();
}


void MainWindow::getSetting()
{
        // setFrm = new settingForm;
    // // //     connect(setFrm.pushButton, SIGNAL(clicked()), this, SLOT(applySetting()));
        setFrm.lineEdit->setText(baseName);
        setFrm.lineEdit_2->setText(userName);
        setFrm.lineEdit_3->setText(password);
//	setFrm->lineEdit_4->setText(tableName);
        setFrm.lineEdit_5->setText(hostName);
        setFrm.show();



}




void MainWindow::readModels(){

    int row = model_for_ListModelsTable->rowCount();
    QList <QTreeWidgetItem*> modelsItemsList;
    QList <int> row_list;
    modelsItemsList = models_items.values();

    row_list = models_items.keys();



    rootItems.clear();
    root_items_list.clear();
    ui->treeWidget->clear();
for (int i=0; i < row; i++){
    QTreeWidgetItem * item_tmp;
    QString modelName;
    QString model_id;

    bool enabled;



    //models_items.values();
    // modelString =

    modelName = model_for_ListModelsTable->data(model_for_ListModelsTable->index(i, 1)).toString();
    model_id = model_for_ListModelsTable->data(model_for_ListModelsTable->index(i, 0)).toString();

    enabled = model_for_ListModelsTable->data(model_for_ListModelsTable->index(i, 3)).toBool();
    item_tmp = new QTreeWidgetItem(ui->treeWidget);
    item_tmp->setText(0, modelName);
    item_tmp->setText(4, QVariant(i).toString()); //   4      
    item_tmp->setText(6, model_id);
    if (enabled) item_tmp->setCheckState(0,Qt::Checked);
    else  item_tmp->setCheckState(0,Qt::Unchecked);

    root_items_list << item_tmp;

    rootItems.append(item_tmp);

    models_items[i] =item_tmp ;


    modelString = model_for_ListModelsTable->data(model_for_ListModelsTable->index(i, 2)).toString();
    if (modelString.isEmpty()) continue;
    else setupModelData(modelString.split(QString("\n")), item_tmp, i, model_id); //  

        }

}




QMap <QString, QPixmap> MainWindow::getClassesIcons(){ //     
                                            //     ID ,     -  

QMap <QString, QPixmap> result_map;
QSqlQuery q;
QString sql_str;
QString str_tmp;
QString field;
QString result;
int field_id, field_icon;
bool ok;
sql_str = tr("select * "
             " from `ListOfClasses` "       //      -   
             );

q.prepare(sql_str);

ok = q.exec();
if (!ok) {
                        QMessageBox::critical( //     .
                                                                        this,                      //  .
                                                                        QObject::tr("Database Error"),   // .
                                                                        q.lastError().text());          //  .
                                                                        return result_map;
                 }
field_id =  q.record().indexOf(tr("ID"));
field_icon = q.record().indexOf(tr("Icon"));
while(q.next()){
    QString classID;
    QByteArray loadimage = q.value(field_icon).toByteArray();
    classID = q.value(field_id).toString();
    if( !loadimage.isEmpty() )
          {
              QPixmap pixmap;
              pixmap.loadFromData(loadimage);
              result_map.insert(classID, pixmap);

          }
    else continue;



    }

return result_map;


}




QMap <QString, QPixmap>  MainWindow::getObjectsIcon(QString inctance){ //     
                                                          //     ID ,     -  
QMap <QString, QPixmap> result_map;
QSqlQuery q;
QString sql_str;
QString str_tmp;
int field_id, field_icon;
bool ok;
sql_str = tr("select `ID`, `Icon` "
             " from `"       //      -   
             );
sql_str.append(inctance);
sql_str.append(tr("`"));

q.prepare(sql_str);

ok = q.exec();
if (!ok) {
                        QMessageBox::critical( //     .
                                                                        this,                      //  .
                                                                        QObject::tr("Database Error"),   // .
                                                                        q.lastError().text());          //  .
                                                                        return result_map;
                 }

field_id =  q.record().indexOf(tr("ID"));
field_icon = q.record().indexOf(tr("Icon"));

while(q.next()){
    QString objectID;
    QByteArray loadimage = q.value(field_icon).toByteArray();
    objectID = q.value(field_id).toString();
    if( !loadimage.isEmpty() )
          {
              QPixmap pixmap;
              pixmap.loadFromData(loadimage);
              result_map.insert(objectID, pixmap);

          }
    else continue;



    }
return result_map;
}




QString  MainWindow::getFiltrString(QString model_id, QString class_id){ //  -     

    QSqlQuery q;
    QString sql_str;
    QString result_str;
    sql_str = tr("select * from `Filters` where `Filters`.`Model_ID` = '");
    sql_str.append(model_id);
    sql_str.append(tr("' and `Filters`.`Class_ID` = '"));
    sql_str.append(class_id);
    sql_str.append(tr("' order by `Filters`.`ID`"));
    bool ok;
    ok = q.prepare(sql_str);
    ok = q.exec();

    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return result_str;
             }
    result_str.clear();
    while(q.next()){
        QString Condition, FieldName, ConditionalSymbol, ValueForComparison, PostCondition;
        Condition = q.record().value(3).toString();
        FieldName =  q.record().value(4).toString();
        ConditionalSymbol = q.record().value(5).toString();
        ValueForComparison = q.record().value(6).toString();
        PostCondition = q.record().value(7).toString();


        result_str.append(Condition);
        result_str.append(tr(" `"));
        result_str.append(FieldName);
        result_str.append(tr("`"));
        result_str.append(ConditionalSymbol);

        if  (!ValueForComparison.isEmpty())       {
                result_str.append(tr("'"));
                result_str.append(ValueForComparison);
                result_str.append(tr("' "));
            }
        result_str.append(PostCondition);


    }


    return result_str;

}


void MainWindow::initWmiTree() {

QSqlQuery q;
QString sqlStr;
QString classID;
QString inctance;
int field_id;
bool ok;
int field_ip, field_user_name, field_password;


sqlStr = tr("select * from `ListOfClasses` where `ListOfClasses`.`ClassName` = 'WmiHost'");
ok = q.prepare(sqlStr);
ok = q.exec();
if (!ok){
                              QMessageBox::critical( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Error"),   // .
                                                    q.lastError().text());          //  .
                                                    return;
         }

field_id = q.record().indexOf(tr("ID"));
if (field_id == -1) return;
else  while  (q.next()){
            classID = q.value(field_id).asString();

        }

inctance = MainWindow::getClassInctance(classID);
if(inctance.isEmpty()) return;
sqlStr = tr("select * from `");
sqlStr.append(inctance);
sqlStr.append(tr("`"));
ok = q.prepare(sqlStr);
ok = q.exec();
if (!ok){
                              QMessageBox::critical( //     .
                                                    this,                      //  .
                                                    QObject::tr("Database Error"),   // .
                                                    q.lastError().text());          //  .
                                                    return;
         }



field_id = q.record().indexOf(tr("ID"));
field_ip = q.record().indexOf(tr("IP"));
field_user_name =  q.record().indexOf(tr(""));
field_password = q.record().indexOf(tr(""));

while  (q.next()){
QString ID_str, IP_str, user_name_str, password_str;
QTreeWidgetItem * itm_tmp;
IP_str = q.value(field_ip).asString();
user_name_str = q.value(field_user_name).asString();
password_str = q.value(field_password).asString();

itm_tmp = new QTreeWidgetItem(ui->treeWidget_3);
itm_tmp->setText(0, IP_str);
itm_tmp->setCheckState(0, Qt::Checked );





TWmiVideoCard vCard;
TWmiMatherBoard mBoard;
TWmiProcessor processor;
QList<TWmiMemoryModul> memory_moduls;
QList<TWmiHDD> hdd_list;
QList<TWmiCDROM> cdrom_list;
QList<TWmiNetCard> netcadr_list;
QList<TWmiSoundCard> soundcard_list;
vCard = MainWindow::getWmiVideoGard(IP_str, user_name_str, password_str);

if (!vCard.name.isEmpty()) {
    QTreeWidgetItem * itm_video;
    QTreeWidgetItem * itm_video_ram;
    QTreeWidgetItem * itm_video_model;
    QTreeWidgetItem * itm_video_manufacturer;
    QString tmp_str;
    tmp_str = tr(": ");
    tmp_str.append(vCard.name);
    tmp_str.append(tr(" "));
    tmp_str.append(QVariant(vCard.video_ram/1024/1024).asString());
    tmp_str.append(tr(" "));
    itm_video = new QTreeWidgetItem(itm_tmp);
    itm_video->setText(0, tmp_str);

    tmp_str = tr(": ");
    tmp_str.append(vCard.manufacturer);

    itm_video_manufacturer = new QTreeWidgetItem(itm_video);
    itm_video_manufacturer->setText(0, tmp_str);

    itm_video_ram = new QTreeWidgetItem(itm_video);

    tmp_str = tr(": ");
    tmp_str.append(vCard.model);
    itm_video_model =  new QTreeWidgetItem(itm_video);
    itm_video_model->setText(0, tmp_str);



    tmp_str = tr(" (): ");
    tmp_str.append(QVariant(vCard.video_ram /1048576).asString());

    itm_video_ram->setText(0,  tmp_str);



                            }


mBoard = MainWindow::getWmiMatherBoard(IP_str, user_name_str, password_str);
if (!mBoard.manufacturer.isEmpty()) {
    QTreeWidgetItem * itm_maherBoard;
    QTreeWidgetItem * itm_maherBoard_model;
    QTreeWidgetItem * itm_maherBoard_manufacturer;
    QString tmp_str;
    tmp_str = tr(" : ");
    tmp_str.append(mBoard.manufacturer);
    tmp_str.append( tr(" "));
    tmp_str.append(mBoard.model);
    itm_maherBoard = new QTreeWidgetItem(itm_tmp);
    itm_maherBoard->setText(0, tmp_str);

    tmp_str = tr(": ");
    tmp_str.append(mBoard.manufacturer);

    itm_maherBoard_manufacturer = new QTreeWidgetItem(itm_maherBoard);
    itm_maherBoard_manufacturer->setText(0, tmp_str);

    itm_maherBoard_model = new QTreeWidgetItem(itm_maherBoard);

    tmp_str = tr(": ");
    tmp_str.append(mBoard.model);

    itm_maherBoard_model->setText(0, tmp_str);


                            }

processor = MainWindow::getWmiProcessor(IP_str, user_name_str, password_str);
if (!processor.manufacturer.isEmpty()){

        QTreeWidgetItem * itm_processor;
        QTreeWidgetItem * itm_processor_manufacturer;
        QTreeWidgetItem * itm_processor_clockSpeed;
        QTreeWidgetItem * itm_processor_socket;


        QString tmp_str;
        tmp_str = tr(": ");
        tmp_str.append(processor.name);

        itm_processor = new QTreeWidgetItem(itm_tmp);
        itm_processor->setText(0, tmp_str);

        tmp_str = tr(": ");
        tmp_str.append(processor.manufacturer);
        itm_processor_manufacturer = new QTreeWidgetItem(itm_processor);
        itm_processor_manufacturer->setText(0,  tmp_str);

        tmp_str = tr(": ");
        tmp_str.append(QVariant(processor.clockSpeed).asString());
        tmp_str.append(tr(" "));
        itm_processor_clockSpeed = new QTreeWidgetItem(itm_processor);
        itm_processor_clockSpeed->setText(0,  tmp_str);


        tmp_str = tr(": ");
        tmp_str.append(processor.socket);
        itm_processor_socket = new QTreeWidgetItem(itm_processor);
        itm_processor_socket->setText(0,  tmp_str);

                            }


memory_moduls = MainWindow::getWmiRAM(IP_str, user_name_str, password_str);

if (!memory_moduls.isEmpty()){
        QTreeWidgetItem * itm_ram;
        int sum_cap=0;
        itm_ram =  new QTreeWidgetItem(itm_tmp);


    for (int i = 0; i < memory_moduls.count(); i++){

         QTreeWidgetItem * itm_ram_modul;
         QTreeWidgetItem * itm_modul_bank;
         QTreeWidgetItem * itm_modul_cap;  //    

         QString tmp_str;
         tmp_str = tr(" : ");
         sum_cap = sum_cap + memory_moduls.at(i).capacity/1024/1024;
         tmp_str.append(QVariant(memory_moduls.at(i).capacity/1024/1024).asString());

         tmp_str.append(tr(" "));
         itm_ram_modul = new QTreeWidgetItem(itm_ram);
         itm_ram_modul->setText(0, tmp_str);


    }
    QString cap_str;
    cap_str = tr(" : ");
    cap_str.append(QVariant(sum_cap).asString());
    cap_str.append(tr(" "));
    itm_ram->setText(0, cap_str);

}


hdd_list = MainWindow::getWmiHDD(IP_str, user_name_str, password_str);


if (!hdd_list.isEmpty()){
        QTreeWidgetItem * itm_hdd_list;
        int sum_cap = 0;
        itm_hdd_list =  new QTreeWidgetItem(itm_tmp);


    for (int i = 0; i < hdd_list.count(); i++){

         QTreeWidgetItem * itm_hdd;
         QTreeWidgetItem * itm_hdd_man;
         QTreeWidgetItem * itm_hdd_cap;
         QTreeWidgetItem * itm_hdd_serNum;
         QTreeWidgetItem * itm_hdd_size;  //    
         long size_lng;
         QString tmp_str;
         tmp_str = tr("Ƹ : ");
         sum_cap = sum_cap + hdd_list.at(i).size/1000/1000;

         tmp_str.append(hdd_list.at(i).caption);
         tmp_str.append(tr(" "));
         size_lng = hdd_list.at(i).size;
         size_lng = size_lng/1000/1000;

         tmp_str.append(QVariant(int(size_lng)).asString());
         tmp_str.append(tr("  s/n: "));

         tmp_str.append(hdd_list.at(i).serialNumber);

         itm_hdd = new QTreeWidgetItem(itm_hdd_list);
         itm_hdd->setText(0, tmp_str);


         tmp_str = tr(": ");
         tmp_str.append((hdd_list.at(i).caption));

         itm_hdd_cap = new QTreeWidgetItem(itm_hdd);
         itm_hdd_cap->setText(0, tmp_str);

         tmp_str = tr(": ");
         tmp_str.append((hdd_list.at(i).manufacturer));

         itm_hdd_man = new QTreeWidgetItem(itm_hdd);
         itm_hdd_man->setText(0, tmp_str);

         tmp_str = tr(" : ");
         tmp_str.append(QVariant(int(size_lng)).asString());
         tmp_str.append(tr(" "));

         itm_hdd_size = new QTreeWidgetItem(itm_hdd);
         itm_hdd_size->setText(0, tmp_str);

         tmp_str = tr(" : ");
         tmp_str.append((hdd_list.at(i).serialNumber));
         itm_hdd_serNum  =  itm_hdd_size = new QTreeWidgetItem(itm_hdd);
         itm_hdd_serNum->setText(0, tmp_str);


    }
    QString cap_str;
    cap_str = tr("   : ");
    cap_str.append(QVariant(sum_cap).asString());
    cap_str.append(tr(" "));
    itm_hdd_list->setText(0, cap_str);

}


cdrom_list = MainWindow::getWmiCDROM(IP_str, user_name_str, password_str);


if (!cdrom_list.isEmpty()){
        QTreeWidgetItem * itm_cdrom_list;

        itm_cdrom_list =  new QTreeWidgetItem(itm_tmp);
        itm_cdrom_list->setText(0, tr("CD/DVD :"));


    for (int i = 0; i < cdrom_list.count(); i++){

         QTreeWidgetItem * itm_cdrom;
         QTreeWidgetItem * itm_cdrom_man;
         QTreeWidgetItem * itm_cdrom_cap;
         QString tmp_str;
         tmp_str = tr(": ");
         tmp_str.append(cdrom_list.at(i).name);

         itm_cdrom = new QTreeWidgetItem(itm_cdrom_list);
         itm_cdrom->setText(0, tmp_str);

         tmp_str = tr(": ");
         tmp_str.append(cdrom_list.at(i).name);


         itm_cdrom_cap = new QTreeWidgetItem( itm_cdrom);
         itm_cdrom_cap->setText(0, tmp_str);


         tmp_str = tr(": ");
         tmp_str.append(cdrom_list.at(i).manufacturer);
         itm_cdrom_man =  new QTreeWidgetItem( itm_cdrom);
         itm_cdrom_man->setText(0, tmp_str);

         ui->treeWidget_3->expandItem( itm_cdrom_list);

    }



}


netcadr_list = MainWindow::getWmiNetCard(IP_str, user_name_str, password_str);


if (!netcadr_list.isEmpty()){
        QTreeWidgetItem * itm_netCard_list;

        itm_netCard_list =  new QTreeWidgetItem(itm_tmp);
        itm_netCard_list->setText(0, tr(" :"));


    for (int i = 0; i < cdrom_list.count(); i++){

         QTreeWidgetItem * itm_net_card;
         QTreeWidgetItem * itm_net_card_mac;
         QTreeWidgetItem * itm_net_card_cap;
         QString tmp_str;
         tmp_str = tr(" : ");
         tmp_str.append(netcadr_list.at(i).caption);

         itm_net_card = new QTreeWidgetItem(itm_netCard_list);
         itm_net_card->setText(0, tmp_str);


         tmp_str = tr(": ");
         tmp_str.append(netcadr_list.at(i).caption);


         itm_net_card_cap = new QTreeWidgetItem(itm_net_card);
         itm_net_card_cap->setText(0, tmp_str);


         tmp_str = tr("MAC : ");
         tmp_str.append(netcadr_list.at(i).MACAddress);
         itm_net_card_mac =  new QTreeWidgetItem(itm_net_card);
         itm_net_card_mac->setText(0, tmp_str);

         ui->treeWidget_3->expandItem( itm_netCard_list);

    }

 }

soundcard_list = MainWindow::getWmiSoundCard(IP_str, user_name_str, password_str);

if (!soundcard_list.isEmpty()){
        QTreeWidgetItem * itm_soundCard_list;

        itm_soundCard_list =  new QTreeWidgetItem(itm_tmp);
        itm_soundCard_list->setText(0, tr(" :"));


    for (int i = 0; i < cdrom_list.count(); i++){

         QTreeWidgetItem * itm_sound_card;
         //QTreeWidgetItem * itm_net_card_mac;
         //QTreeWidgetItem * itm_sou_card_cap;
         QString tmp_str;
         tmp_str = tr(" : ");
         tmp_str.append(soundcard_list.at(i).caption);

         itm_sound_card = new QTreeWidgetItem(itm_soundCard_list);
         itm_sound_card->setText(0, tmp_str);




         ui->treeWidget_3->expandItem( itm_soundCard_list);

    }







        }

ui->treeWidget_3->expandItem(itm_tmp);
// itm_tmp->setChildIndicatorPolicy(QTreeWidget::
int i;
i++;


    } //while



}





